﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace C1Flexgrid_Transpose
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        Image asc_img, desc_image;
        Boolean flag;
        C1.Win.C1FlexGrid.CellStyle cs;

        private void Form1_Load(object sender, EventArgs e)
        {
            // TODO: This line of code loads data into the 'c1NWindDataSet.Employees' table. You can move, or remove it, as needed.
            this.employeesTableAdapter.Fill(this.c1NWindDataSet.Employees);
            
            asc_img = this.c1FlexGrid1.Glyphs[C1.Win.C1FlexGrid.GlyphEnum.Ascending];
            desc_image = this.c1FlexGrid1.Glyphs[C1.Win.C1FlexGrid.GlyphEnum.Descending];

            //set transposed datatable as grid's datasource
            this.c1FlexGrid1.DataSource = TransposeTable(this.c1NWindDataSet.Employees);
                        
            //Create a custom style for frozen rows/cols
            cs = this.c1FlexGrid1.Styles.Add("Custom", this.c1FlexGrid1.Styles.Frozen);
            cs.BackColor = this.c1FlexGrid1.Styles.Fixed.BackColor;
            cs.Border.Style = C1.Win.C1FlexGrid.BorderStyleEnum.Raised;       

            UpdateRowColSettings();

            //Implement Sort at Row Header Click
            this.c1FlexGrid1.MouseUp += (s1, e1) =>
            {
                var flex = s1 as C1.Win.C1FlexGrid.C1FlexGrid;
                var hittest = flex.HitTest(e1.X, e1.Y);

                int row = hittest.Row;
                int col = hittest.Column;

                if (col == 0 && row != 0)
                {
                    flex.BeginUpdate();

                    string colname = flex[row, col].ToString();
                    string sort = this.c1NWindDataSet.Employees.DefaultView.Sort;

                    if (sort == "")
                    {
                        sort = colname + " ASC";
                        flag = true;
                    }
                    else
                    {
                        if (sort == colname + " ASC")
                        {
                            sort = colname + " DESC";
                            flag = false;
                        }
                        else
                        {
                            sort = colname + " ASC";
                            flag = true;
                        }
                    }

                    this.c1NWindDataSet.Employees.DefaultView.Sort = sort;

                    //reset grid's datasource and set Sorted DataView as grid's DataSource
                    flex.DataSource = TransposeTable(this.c1NWindDataSet.Employees.DefaultView.ToTable());

                    //Update Fixed Rows/Cols
                    UpdateRowColSettings();

                    //Update and Display SortGylphs
                    if (flag)
                        flex.SetCellImage(row, col, asc_img);
                    else
                        flex.SetCellImage(row, col, desc_image);
                    
                    //Set current Row
                    flex.Row = row;
                    flex.EndUpdate();
                }
            };
        }

        private void UpdateRowColSettings()
        {
            this.c1FlexGrid1.Cols.Fixed = 0;
            this.c1FlexGrid1.Rows.Fixed = 0;
            this.c1FlexGrid1.Rows.InsertNode(0, -1);
            this.c1FlexGrid1.Cols.Frozen = 1;
            this.c1FlexGrid1.Rows.Frozen = 1;
            this.c1FlexGrid1.Rows[0].Style = this.c1FlexGrid1.Styles["Custom"];
            this.c1FlexGrid1.Cols[0].Style = this.c1FlexGrid1.Styles["Custom"];
            this.c1FlexGrid1.Cols[0].AllowEditing = false;
            this.c1FlexGrid1.Rows[0].AllowEditing = false;            
            this.c1FlexGrid1.Cols[0].ImageAlign = C1.Win.C1FlexGrid.ImageAlignEnum.RightCenter;
            this.c1FlexGrid1.AutoSizeCol(0);
        }

        //return transposed datatable
        private DataTable TransposeTable(DataTable table)
        {
            DataTable outputTable = new DataTable();
            outputTable.Columns.Add(table.Columns[0].ColumnName.ToString());
            foreach (DataRow inRow in table.Rows)
            {
                string newColName = inRow[0].ToString();
                outputTable.Columns.Add(newColName);
            }
            for (int rCount = 0; rCount <= table.Columns.Count - 1; rCount++)
            {
                DataRow newRow = outputTable.NewRow();
                newRow[0] = table.Columns[rCount].ColumnName.ToString();
                for (int cCount = 0; cCount <= table.Rows.Count - 1; cCount++)
                {
                    string colValue = table.Rows[cCount][rCount].ToString();
                    newRow[cCount + 1] = colValue;
                }
                outputTable.Rows.Add(newRow);
            }
            return outputTable;
        }
    }
}
